//Log facilities
//////////////////////////////////////////////////////
#ifndef _LOG_H_
#define _LOG_H_

extern pthread_mutex_t	logLock;

#define APPEND2LOG(fname, fmt...) \
		do {\
			FILE *fp;\
			time_t ltime;\
			char buf[28];\
			pthread_mutex_lock (&logLock);\
			fp = fopen (fname, "a");\
			if (fp) {\
				time (&ltime);\
				ctime_r (&ltime, buf);\
				buf[24] = buf[25] = ' ';\
				buf[26] = 0;\
				fprintf (fp, "%s", buf);\
				fprintf (fp, fmt);\
				fclose (fp);\
			}\
			pthread_mutex_unlock (&logLock);\
		} while (0)

#define RESETLOG(fname) \
		do {\
			FILE *fp;\
			pthread_mutex_lock (&logLock);\
			fp = fopen (fname, "w");\
			if (fp) {\
				fclose (fp);\
			}\
			pthread_mutex_unlock (&logLock);\
		} while (0)

#endif	//_LOG_H_

//////////////////////////////////////////////////////

