/***************************************** (C) COPYRIGHT 2010 Intersil *****************************************
* File Name         : isil_rc_wrapper.h
* Author            : tang.sc@intersil.com
* Revision          : 1.2.1.1275
* Date              : 2012-03-29
* Description       : 
* Change log        : 
*                   
****************************************************************************************************************
* THE PRESENT SOFTWARE IS DISTRIBUTED IN THE HOPE THAT IT WILL PROVIDE CUSTOMERS 
* WITH CODING INFORMATION TO SPEED UP THEIR PRODUCT DEVELOPMENT, BUT WITHOUT
* ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS
* FOR A PARTICULAR PURPOSE. AS A RESULT, TECHWELL SHALL NOT BE HELD LIABLE FOR ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
****************************************************************************************************************/
#ifndef _DVM_RC_H_
#define _DVM_RC_H_

#ifdef __cplusplus
extern "C"
{
#endif

#define QUANT_SCALE_MIN (16)
#define QUANT_SCALE_MAX (45)

    struct rate_control_driver_op
    {
	void	(*init_rc)(isil_h264_logic_encode_chan_t *);
	void	(*set_qp)(isil_h264_logic_encode_chan_t *, isil_video_frame_tcb_t *);
	void	(*update_rc)(isil_h264_logic_encode_chan_t *);
	void	(*jump_rc)(isil_h264_logic_encode_chan_t *);
    };

    struct cbr_driver
    {
	struct h264_encoder_t   h264_rc_info;
	isil_rc_driver_op       *rc_op;
    };

    struct vbr_driver
    {
	struct h264_encoder_t   h264_rc_info;
        int     image_level;
	isil_rc_driver_op       *rc_op;
    };

    struct rc_top_driver
    {
	isil_rc_driver_op   *rc_op;
	isil_cbr_driver_t   cbr;	
	isil_vbr_driver_t   vbr;	
    };

    extern void	init_rc_driver(isil_h264_logic_encode_chan_t *h264_logic_encode_chan);

#ifdef __cplusplus
}
#endif

#endif

